#141 Xclearcase Kills XDarwin

Causes Crash
closed-fixed
Rootless (76)
7
2001-12-23
2001-12-04
Anonymous
No

I have a consistent crash using a tool called
Xclearcase in rootless mode. This is a X-Windows
GUI to the configuration management tool
"Clearcase" by Rational. This only seems to crash
in rootless mode but is repeatable. I'm connecting
to an SGI. Here is the crash log. (This is the first
bug I've submitted so If there is some other
information I'm missing, I can add that) I'm running
on a dual 450 G4 system with 2 ATI 128 video
cards and 640 MEG of ram.:

Date/Time: 2001-12-04 07:44:56 -0500
OS Version: 10.1.1 (Build 5M28)

Command: XDarwin
PID: 27201

Exception: EXC_BAD_ACCESS (0x0001)
Codes: KERN_INVALID_ADDRESS (0x0001) at
0x04172984

Thread 0:
#0 0x70001308 in mach_msg_overwrite_trap
#1 0x70006394 in mach_msg
#2 0x7017bebc in __CFRunLoopRun
#3 0x701b6ba0 in CFRunLoopRunSpecific
#4 0x7017b804 in CFRunLoopRunInMode
#5 0x7312d614 in
RunEventLoopInModeUntilEventArrives
#6 0x7314056c in ReceiveNextEventCommon
#7 0x73171340 in
BlockUntilNextEventMatchingListInMode
#8 0x70bd70b8 in _DPSNextEvent
#9 0x70bfe5d8 in -[NSApplication
nextEventMatchingMask:untilDate:inMode:dequeue
:]
#10 0x70c23468 in -[NSApplication run]
#11 0x70c91ed0 in NSApplicationMain
#12 0x00002768 in DarwinHandleGUI
#13 0x000028e0 in main
#14 0x0000253c in _start
#15 0x0000236c in start

Thread 1:
#0 0x0004af5c in fbBlt
#1 0x0004bb14 in fbBltStip
#2 0x0005473c in fbGetImage
#3 0x000cdeb0 in miSpriteGetImage
#4 0x0026ab90 in RootlessGetImage
#5 0x00062f08 in XineramaGetImageData
#6 0x0006a4c8 in PanoramiXCopyArea
#7 0x0001b9ec in Dispatch
#8 0x00002f04 in main
#9 0x00266c00 in -[Xserver run]
#10 0x70842358 in forkThreadForFunction
#11 0x70020efc in _pthread_body

Thread 2:
#0 0x70001308 in mach_msg_overwrite_trap
#1 0x70006394 in mach_msg
#2 0x700273dc in _pthread_become_available
#3 0x700270d4 in pthread_exit
#4 0x70020f00 in _pthread_body

PPC Thread State:
srr0: 0x0004af5c srr1: 0x0000d030
vrsave: 0x00000000
xer: 0x00000004 lr: 0x0004aa68 ctr:
0x00054558 mq: 0x00000000
r0: 0x00000c88 r1: 0x02031860 r2:
0x03f025a8 r3: 0x0000000b
r4: 0x00000322 r5: 0x00000000 r6:
0x04172984 r7: 0x03e66140
r8: 0x00000000 r9: 0x00000014 r10:
0x00000000 r11: 0x002e4188
r12: 0x00000004 r13: 0x00000000 r14:
0x00000033 r15: 0x0005f610
r16: 0x00000001 r17: 0x80160e88 r18:
0x0005bcb8 r19: 0x00002203
r20: 0x00000000 r21: 0x0000001c r22:
0x70004bc4 r23: 0x70004c58
r24: 0x7016b214 r25: 0x006bac3c r26:
0x8081ab5c r27: 0xc0d19400
r28: 0x00000000 r29: 0xbfffef00 r30:
0x00000000 r31: 0x00000001

**********

Discussion

1 2 > >> (Page 1 of 2)
  • Greg Parker

    Greg Parker - 2001-12-04

    Logged In: YES
    user_id=37183

    What version of XDarwin are you using? (Check XDarwin's About box)

    You say you have two video cards. Are you using two screens? How are they arranged? XDarwin prints the screen configuration in its startup output (check Console.app). There have been bugs with multiple screens depending on the screen arrangement, though I haven't seen one with that backtrace yet.

    (In general, XDarwin's output from Console.app is useful in a bug report - that will include XDarwin's version and setup and any error messages it printed before it died.)

     
  • Nobody/Anonymous

    Logged In: NO

    XFree86 Version 4.1.99.1 / X Window System
    (protocol Version 11, revision 0, vendor release 6510)
    Release Date: xx October 2001
    If the server is older than 6-12 months, or if your
    hardware is
    newer than the above date, look for a newer version
    before
    reporting problems. (See http://www.XFree86.Org/
    FAQ)
    Operating System: Darwin
    Using keymapping provided in /System/Library/
    Keyboards/USA.keymapping.
    Warning: no access to tty (Inappropriate ioctl for
    device).
    Thus no job control in this shell.
    _XSERVTransmkdir: Owner of /tmp/.X11-unix should be
    set to root

    Display mode: Rootless Quartz
    Screen 0 added: 1280x1003 @ (0,21)
    Screen 1 added: 1280x1024 @ (1280,0)
    Screen 0 placed at X11 coordinate (0,0).
    Screen 1 placed at X11 coordinate (1280,-21).

     
  • Mark Miller

    Mark Miller - 2001-12-04

    Logged In: YES
    user_id=393399

    Sorry, forgot the XDarwin version. It's 1.0.4.

     
  • Greg Parker

    Greg Parker - 2001-12-04

    Logged In: YES
    user_id=37183

    One of the known bugs was caused by two screens with one of them in negative screen space. You might try rearranging the screens and see if that fixes the bug. Try putting the Mac menu bar on the right, or keep the menu bar on the left and move the right-side monitor down so its top is below the bottom of the menu bar.

     
  • Torrey T. Lyons

    Torrey T. Lyons - 2001-12-06
    • status: open --> open-fixed
     
  • Torrey T. Lyons

    Torrey T. Lyons - 2001-12-06

    Logged In: YES
    user_id=133579

    As Greg said, screen rearrangement may help you. In any case, we believe this bug is fixed in the forthcoming XDarwin 1.0.5. Since you have a repeatable crash, it would be very good if you could confirm this.

     
  • Greg Parker

    Greg Parker - 2001-12-06

    Logged In: YES
    user_id=37183

    Actually, I don't believe the ClearCase problem will be fixed in XDarwin 1.0.5. The known negative space bug died in line drawing; this crash is in a different place. You should try screen rearrangement and 1.0.5 anyway.

     
  • Torrey T. Lyons

    Torrey T. Lyons - 2001-12-06

    Logged In: YES
    user_id=133579

    Good point. I've unmarked this one fixed and bumped up its priority. A repeatable crasher like this in fbBlt is important to track down. It would help if you could try the screen rearrangement so we can tell if it is the negative y coordinate that is triggering the bug.

     
  • Torrey T. Lyons

    Torrey T. Lyons - 2001-12-06
    • priority: 5 --> 7
     
  • Mark Miller

    Mark Miller - 2001-12-06

    Logged In: YES
    user_id=393399

    I tried 2 more experiments. First, my displays are set up
    with the left having the menu bar. The first test was to
    offset the right display. I dragged it down so it was about
    offset about 20. I still got the crash. Next, I re-aligned
    the displays and moved the menu bar from the left to the
    right display. Crashed again.

    I can submit the crash logs, but if it looks like the
    problem is in fbBlt, both crashes have identical stack
    traces for Thread 1 in the submission above.

     
  • Greg Parker

    Greg Parker - 2001-12-06

    Logged In: YES
    user_id=37183

    Sounds like the negative screen space isn't the problem. To make absolutely sure, look at XDarwin's output with the rearranged screens and make sure that both "Screen N placed at X11 coordinate (x, y)" are using nonnegative coordinates for the screens. (It's actually still possible that negative space is the problem, if Xclearcase is making a window offscreen in negative space.)

    One other test that you can try: disable one of the screens. I don't think there's a way to do this in XDarwin, so you'll have to unplug a monitor and reboot.

     
  • Mark Miller

    Mark Miller - 2001-12-06

    Logged In: YES
    user_id=393399

    I first checked the screen coordinates for screen 1 and the
    coordinates were indeed positive when I had dragged the
    monitor down a bit. Xclearcase seems to be placing any
    window it opens on screen 0 (from what I can see anyway).

    Next, I unplugged the second monitor, restarted, rlogin'ed
    in my SGI kicked off XClearCase and no crash! It's
    definitely a multiple monitor thing it would seem. Any other
    suggestions? I won't be able to try again till Monday though.

     
  • Greg Parker

    Greg Parker - 2001-12-06

    Logged In: YES
    user_id=37183

    Definitely a multi-screen problem, then. I have a guess now. It's dying inside GetImage, which is interesting in that it's almost the only function that reads from a window image instead of writing to a window. And if my disassembly is correct, the actual crash is when it tries to read a pixel. I'll look at my implementation of RootlessGetImage again. If I don't see the problem, I'll put together a custom XDarwin with extra diagnostic output for you to try.

     
  • Greg Parker

    Greg Parker - 2001-12-09

    Logged In: YES
    user_id=37183

    This might be fixed by patch #490827 "Multi-screen GetImage fix". I'll try to build a binary for you to test soon.

     
  • Greg Parker

    Greg Parker - 2001-12-10

    Logged In: YES
    user_id=37183

    I've posted a new XDarwin.app at http://www.sealiesoftware.com/xdarwin-getimage.dmg.gz . Move your existing XDarwin.app out of the way and drop this one in its place. Let me know whether it fixes the problem or not.

     
  • Mark Miller

    Mark Miller - 2001-12-10

    Logged In: YES
    user_id=393399

    Are there any other steps to getting this to run? i.e.
    deleting preferences etc.? It doesn't launch for me. It seem
    to start but even before an icon pops up in the dock, it
    quits. No crashlog either.

     
  • Mark Miller

    Mark Miller - 2001-12-10

    Logged In: YES
    user_id=393399

    Are there any other steps to getting this to run? i.e.
    deleting preferences etc.? It doesn't launch for me. It seem
    to start but even before an icon pops up in the dock, it
    quits. No crashlog either.

     
  • Benn Tannenbaum

    Benn Tannenbaum - 2001-12-10

    Logged In: YES
    user_id=398341

    Adding a comment-- I've got a Rev 1 TiBook that gives me the
    same crash. I can get repeated crashes using Adobe Acrobat
    Reader- several files crash on loading, and others crash
    after mousing around inside the .pdf file. I can also get
    crashes from Nedit, Netscape and a few programs from the LSF
    package. Nedit does work for quite a while; I have to earn
    that crash. I can drag XWindows around from screen to screen
    with no problem.... Note that I use this laptop with two
    different external monitors. In one case the laptop is to
    the left of the external monitor and the Apple menu is on
    the external monitor, and in the other case the laptop is on
    the right of the external monitor and the Apple menu is on
    the laptop. My most recent crash is appended below.

    Date/Time: 2001-12-10 10:12:09 -0800
    OS Version: 10.1.1 (Build 5M28)

    Command: XDarwin
    PID: 8214

    Exception: EXC_BAD_ACCESS (0x0001)
    Codes: KERN_INVALID_ADDRESS (0x0001) at 0x024b3858

    Thread 0:
    #0 0x70001308 in mach_msg_overwrite_trap
    #1 0x70006454 in mach_msg
    #2 0x7017bebc in __CFRunLoopRun
    #3 0x701b6ba0 in CFRunLoopRunSpecific
    #4 0x7017b804 in CFRunLoopRunInMode
    #5 0x7312d614 in RunEventLoopInModeUntilEventArrives
    #6 0x7314056c in ReceiveNextEventCommon
    #7 0x73171340 in BlockUntilNextEventMatchingListInMode
    #8 0x70bd70b8 in _DPSNextEvent
    #9 0x70bfe5d8 in -[NSApplication
    nextEventMatchingMask:untilDate:inMode:deque
    ue:]
    #10 0x70c23468 in -[NSApplication run]
    #11 0x70c91ed0 in NSApplicationMain
    #12 0x0000218c in DarwinHandleGUI
    #13 0x00002304 in main
    #14 0x00001f60 in _start
    #15 0x00001d90 in start

    Thread 1:
    #0 0x0004aa64 in fbBlt
    #1 0x0004b61c in fbBltStip
    #2 0x00054244 in fbGetImage
    #3 0x000cdb64 in miSpriteGetImage
    #4 0x00270a80 in RootlessGetImage
    #5 0x00062ad8 in XineramaGetImageData
    #6 0x0006c7a4 in PanoramiXGetImage
    #7 0x0001b410 in Dispatch
    #8 0x00002928 in main
    #9 0x0026ca14 in -[Xserver run]
    #10 0x70842358 in forkThreadForFunction
    #11 0x70020efc in _pthread_body

    PPC Thread State:
    srr0: 0x0004aa64 srr1: 0x0000d030 vrsave:
    0x00000000
    xer: 0x00000004 lr: 0x0004a570 ctr: 0x00054060 mq:
    0x00000000
    r0: 0x00001200 r1: 0x0241c8a0 r2: 0x03b43300 r3:
    0x0000000d
    r4: 0x00000480 r5: 0x00000000 r6: 0x024b3858 r7:
    0x03b48120
    r8: 0x00000000 r9: 0x00000068 r10: 0x00000000 r11:
    0x002ea1c0
    r12: 0x00000019 r13: 0x00000000 r14: 0x00000033 r15:
    0x0004a010
    r16: 0xbfffee70 r17: 0x00000000 r18: 0x00000014 r19:
    0x0000101f
    r20: 0x00000000 r21: 0x0000001c r22: 0x70004bc4 r23:
    0x70004c58
    r24: 0x00000001 r25: 0x0004b060 r26: 0x00000000 r27:
    0x013556e0
    r28: 0x00000000 r29: 0xbfffef00 r30: 0x00000000 r31:
    0x00000001

    **********

     
  • Greg Parker

    Greg Parker - 2001-12-10

    Logged In: YES
    user_id=37183

    Sorry, the binary I built is broken. You might try opening a terminal, setting the DYLD_LIBRARY_PATH variable to your X11 library directory and then running XDarwin from that terminal. (In tcsh, `setenv DYLD_LIBRARY_PATH /usr/X11R6/lib ; startx -- -rootless`.) I'll make a fixed binary soon.

     
  • Mark Miller

    Mark Miller - 2001-12-11

    Logged In: YES
    user_id=393399

    I just ran the XDarwin 1.0.5 test. I think we're getting the
    same error:

    Date/Time: 2001-12-11 09:09:42 -0500
    OS Version: 10.1.1 (Build 5M28)

    Command: XDarwin
    PID: 480

    Exception: EXC_BAD_ACCESS (0x0001)
    Codes: KERN_INVALID_ADDRESS (0x0001) at 0x03edb984

    Thread 0:
    #0 0x70001308 in mach_msg_overwrite_trap
    #1 0x70006394 in mach_msg
    #2 0x7017bebc in __CFRunLoopRun
    #3 0x701b6ba0 in CFRunLoopRunSpecific
    #4 0x7017b804 in CFRunLoopRunInMode
    #5 0x7312d614 in RunEventLoopInModeUntilEventArrives
    #6 0x7314056c in ReceiveNextEventCommon
    #7 0x73171340 in BlockUntilNextEventMatchingListInMode
    #8 0x70bd70b8 in _DPSNextEvent
    #9 0x70bfe5d8 in -[NSApplication
    nextEventMatchingMask:untilDate:inMode:dequeue:]
    #10 0x70c23468 in -[NSApplication run]
    #11 0x70c91ed0 in NSApplicationMain
    #12 0x00002bec in DarwinHandleGUI
    #13 0x00002e58 in main
    #14 0x00002938 in _start
    #15 0x00002768 in start

    Thread 1:
    #0 0x00078548 in fbBlt
    #1 0x00079ed0 in fbBltStip
    #2 0x0008ea58 in fbGetImage
    #3 0x00164e00 in miSpriteGetImage
    #4 0x004757c0 in RootlessGetImage
    #5 0x000af1c8 in XineramaGetImageData
    #6 0x000bb02c in PanoramiXCopyArea
    #7 0x0002964c in Dispatch
    #8 0x000036a4 in main
    #9 0x0046ec94 in -[Xserver run]
    #10 0x70842358 in forkThreadForFunction
    #11 0x70020efc in _pthread_body

    PPC Thread State:
    srr0: 0x00078548 srr1: 0x0000d030 vrsave:
    0x00000000
    xer: 0x00000004 lr: 0x00077b50 ctr: 0x0008e680 mq:
    0x00000000
    r0: 0x00000004 r1: 0x02d64880 r2: 0x03c2afe0 r3:
    0x03edb960
    r4: 0x00000322 r5: 0x00000120 r6: 0x03e47a50 r7:
    0x00000005
    r8: 0x00000000 r9: 0x02d648cc r10: 0x03edb984 r11:
    0x03e47a50
    r12: 0x0008e680 r13: 0x00000000 r14: 0x00000033 r15:
    0xbfffee58
    r16: 0xbfffee70 r17: 0x00000001 r18: 0x00063768 r19:
    0x00002603
    r20: 0x00000000 r21: 0x0000001c r22: 0x70004bc4 r23:
    0x70004c58
    r24: 0x706bab4c r25: 0x000006eb r26: 0x8081ab5c r27:
    0x00063fa0
    r28: 0x00000000 r29: 0xbfffef00 r30: 0x8081d1cc r31:
    0x00000001

    **********

     
  • Benn Tannenbaum

    Benn Tannenbaum - 2001-12-11

    Logged In: YES
    user_id=398341

    I tried the latest build (11 December @ 1:28 am) and it
    still gives me the same crash.

    Date/Time: 2001-12-11 08:50:35 -0800
    OS Version: 10.1.1 (Build 5M28)

    Command: XDarwin
    PID: 949

    Exception: EXC_BAD_ACCESS (0x0001)
    Codes: KERN_PROTECTION_FAILURE (0x0002) at
    0x0000003c

    Thread 0:
    #0 0x70001308 in mach_msg_overwrite_trap
    #1 0x70006454 in mach_msg
    #2 0x7017bebc in __CFRunLoopRun
    #3 0x701b6ba0 in CFRunLoopRunSpecific
    #4 0x7017b804 in CFRunLoopRunInMode
    #5 0x7312d614 in
    RunEventLoopInModeUntilEventArrives
    #6 0x7314056c in ReceiveNextEventCommon
    #7 0x73171340 in
    BlockUntilNextEventMatchingListInMode
    #8 0x70bd70b8 in _DPSNextEvent
    #9 0x70bfe5d8 in -[NSApplication
    nextEventMatchingMask:untilDate:inMode:dequeue:]
    #10 0x70c23468 in -[NSApplication run]
    #11 0x70c91ed0 in NSApplicationMain
    #12 0x00002bec in DarwinHandleGUI
    #13 0x00002e58 in main
    #14 0x00002938 in _start
    #15 0x00002768 in start

    Thread 1:
    #0 0x00475710 in RootlessGetImage
    #1 0x000af1c8 in XineramaGetImageData
    #2 0x000bb02c in PanoramiXCopyArea
    #3 0x0002964c in Dispatch
    #4 0x000036a4 in main
    #5 0x0046ec94 in -[Xserver run]
    #6 0x70842358 in forkThreadForFunction
    #7 0x70020efc in _pthread_body

    PPC Thread State:
    srr0: 0x00475710 srr1: 0x0000d030 vrsave:
    0x00000000
    xer: 0x00000004 lr: 0x004756dc ctr: 0x00033f1c
    mq: 0x00000000
    r0: 0x00000000 r1: 0x0315fa70 r2: 0x0423d034
    r3: 0x040cc500
    r4: 0x006001d8 r5: 0xc0000001 r6: 0x00000000
    r7: 0x0000000f
    r8: 0x00000009 r9: 0x040cc58c r10: 0x00000002
    r11: 0x00000000
    r12: 0x000ac2dc r13: 0x00000000 r14: 0x00000036
    r15: 0x0004a010
    r16: 0xbfffee70 r17: 0x00000000 r18: 0x00000014
    r19: 0x00003c0b
    r20: 0x00000000 r21: 0x0000001c r22: 0x70004bc4
    r23: 0x70004c58
    r24: 0x00000001 r25: 0x0004b060 r26: 0x00000000
    r27: 0x0005cb00
    r28: 0x00000000 r29: 0xbfffef00 r30: 0x00000000
    r31: 0x00000001

    **********

     
  • Greg Parker

    Greg Parker - 2001-12-12

    Logged In: YES
    user_id=37183

    marknews, it looks like you're experiencing exactly the same bug. Does the second XDarwin.app binary that I posted (http://www.sealiesoftware.com/xdarwin-getimage-2.dmg.gz) work better?

    bennht, your newest crash is different but related. This may be progress :-) Note that Thread 1 now dies in RootlessGetImage, instead of in fbBlt. Does the new binary always die in RootlessGetImage itself? Does the new binary ever die in fbBlt?

     
  • Greg Parker

    Greg Parker - 2001-12-12

    Logged In: YES
    user_id=37183

    Oops, I think I left out some critical checks in binary #2, which would make it work correctly for onscreen windows and die in RootlessGetImage for offscreen ones. bennht, can you try http://www.sealiesoftware.com/xdarwin-getimage-3.dmg.gz ?

     
  • Mark Miller

    Mark Miller - 2001-12-12

    Logged In: YES
    user_id=393399

    I tried both the 2 and 3 images and still crash. I have both
    crashlogs. Here's the one for image 2. If you only need a
    portion of this, let me know.

    Command: XDarwin
    PID: 1837

    Exception: EXC_BAD_ACCESS (0x0001)
    Codes: KERN_INVALID_ADDRESS (0x0001) at 0x04803984

    Thread 0:
    #0 0x70001308 in mach_msg_overwrite_trap
    #1 0x70006394 in mach_msg
    #2 0x7017bebc in __CFRunLoopRun
    #3 0x701b6ba0 in CFRunLoopRunSpecific
    #4 0x7017b804 in CFRunLoopRunInMode
    #5 0x7312d614 in RunEventLoopInModeUntilEventArrives
    #6 0x7314056c in ReceiveNextEventCommon
    #7 0x73171340 in BlockUntilNextEventMatchingListInMode
    #8 0x70bd70b8 in _DPSNextEvent
    #9 0x70bfe5d8 in -[NSApplication
    nextEventMatchingMask:untilDate:inMode:dequeue:]
    #10 0x70c23468 in -[NSApplication run]
    #11 0x70c91ed0 in NSApplicationMain
    #12 0x00002bec in DarwinHandleGUI
    #13 0x00002e58 in main
    #14 0x00002938 in _start
    #15 0x00002768 in start

    Thread 1:
    #0 0x00078548 in fbBlt
    #1 0x00079ed0 in fbBltStip
    #2 0x0008ea58 in fbGetImage
    #3 0x00164e00 in miSpriteGetImage
    #4 0x004757c0 in RootlessGetImage
    #5 0x000af1c8 in XineramaGetImageData
    #6 0x000bb02c in PanoramiXCopyArea
    #7 0x0002964c in Dispatch
    #8 0x000036a4 in main
    #9 0x0046ec94 in -[Xserver run]
    #10 0x70842358 in forkThreadForFunction
    #11 0x70020efc in _pthread_body

    PPC Thread State:
    srr0: 0x00078548 srr1: 0x0000d030 vrsave:
    0x00000000
    xer: 0x00000014 lr: 0x00077b50 ctr: 0x0008e680 mq:
    0x00000000
    r0: 0x00000004 r1: 0x02e6e880 r2: 0x044a9560 r3:
    0x04803960
    r4: 0x00000322 r5: 0x00000120 r6: 0x046e2680 r7:
    0x00000005
    r8: 0x00000000 r9: 0x02e6e8cc r10: 0x04803984 r11:
    0x046e2680
    r12: 0x0008e680 r13: 0x00000000 r14: 0x00000033 r15:
    0x0004a010
    r16: 0xbfffee70 r17: 0x00000000 r18: 0x00574aa8 r19:
    0x00002b07
    r20: 0x00000000 r21: 0x0000001c r22: 0x70004bc4 r23:
    0x70004c58
    r24: 0x706bab4c r25: 0x000006eb r26: 0x8081ab5c r27:
    0x0056de50
    r28: 0x00000000 r29: 0xbfffef00 r30: 0x00000000 r31:
    0x00000001

    **********

     
1 2 > >> (Page 1 of 2)

Log in to post a comment.